
' termometr do bufora
' Marian Gabrowski


$regfile = "m8adef.dat"
$crystal = 3686400
$baud = 2400

Declare Sub Nadawanie
Declare Sub Odbieranie
Declare Sub Pomiar

Config Pind.2 = Output                                      'tx_rx RS485
Nadawanie_odbieranie Alias Portd.2                          'tx_rx RS485
Config 1wire = Portd.3                                      'tutaj podczymy termometry 1-wire


Config Watchdog = 2048
Start Watchdog

Dim Odczyt(9) As Byte                                       'tablica na 9 bajtw odczytanych z DS18B20 - caa dostpna pami
Dim T As Integer                                            'temperatura w "kwantach" 1/16 stopnia
Dim T_suma As Integer                                       'suma odczytanych temperatur (jako suma kontrolna przy transmisji via RS485)
Dim T2 As Single                                            'temperatura jako liczba rzeczywista

Dim Ile As Byte                                             'liczba czujnikw znalezionych na magistrali 1wire
Dim N As Byte                                               'zmienna pomocnicza dla petli for

Dim Adres(160) As Byte                                      'tablica na "64-bit lasered ROM code" znalezionych termometrow, jeden termometr zuzywa 8 bajtow
Dim Gdzie As Byte                                           'adres Gdzie znajduje si pierwszy bajt "lasered"
Dim Gdzie8 As Byte                                          'adres Gdzie znajduje si ostatni bajt "lasered"
Dim Crc As Byte                                             'suma CRC obliczona przez mikrokontroler
Dim Crc_ok As Byte                                          'flaga informujaca, czy obliczone sumy CRC byy zgodne z przesanymi
Dim Czas As Word                                            'liczba pustych przebiegow petli glownej
Dim Numer As Byte                                           'numer aktualnie wybranego czujnika
Dim Znak As Byte                                            ' znak odczytany z RS



Odbieranie
Czas = 0

Do
  Reset Watchdog
  Znak = Inkey()
  If Znak = Asc( "b") Then
     Gosub Pokaz_rs485
     Czas = 0
  End If
  Waitms 50
  Incr Czas
  If Czas > 6000 Then                                       'jesli dane nie zostaly odczytane przez RS485 w czasie 6000*50ms = 300.000 ms = 300 s = 5 minut
     Waitms 5000                                            'to resetujemy mikrokontroler (zresetuje go watchdog ustawiony na 2s)
  End If
Loop
End


Pokaz_rs485:
  Waitms 50
  Nadawanie
  Pomiar
  Odbieranie
Return

Sub Nadawanie
  Waitms 25
  Set Nadawanie_odbieranie
  Waitms 25
End Sub

Sub Odbieranie
  Waitms 25
  Reset Nadawanie_odbieranie
  Waitms 25
End Sub

Sub Pomiar
   Ile = 1wirecount()                                       'sprawdzamy liczb termometrw na magistrali
   Print "1WIRECOUNT=" ; Ile ; ";";                         'pokazujemy ile znaleziono
   If Ile < 1 Then
      Crc_ok = 0                                            'jak nie znaleziono czujnikw to i brak poprawnej sumy
   Else                                                     'jesli czujniki s
      For Numer = 1 To Ile
         Gdzie = Numer * 8
         If Numer = 1 Then
            Adres(gdzie) = 1wsearchfirst()
         Else
            Adres(gdzie) = 1wsearchnext()
         End If
      Next Numer

      1wreset                                               '1wire reset
      1wwrite &HCC                                          'command Skip ROM
      1wwrite &H44                                          'command Convert T

      Waitms 825                                            'max temperature coversion time = 750ms + 10%
      Reset Watchdog

      Crc_ok = 1                                            'zakadamy, e na pocztku CRC jest OK
      T_suma = 0
      For Numer = 1 To Ile                                  'dla kazdego numeru czujnika
         Reset Watchdog
         Gdzie = Numer * 8
         Gdzie8 = Gdzie + 7
         For N = Gdzie To Gdzie8                            'pokazujemy osiem bajtw
            Print Hex(adres(n));                            'jego adresu "64-bit lasered ROM code"
         Next N
         Print "=";
         1wreset                                            '1wire reset
         1wwrite &H55                                       'command Match ROM
         1wwrite Adres(gdzie) , 8                           'wysyamy na magistral 8 bajtw adresu ROM
         1wwrite &HBE                                       'command Read Scratchpad
         Odczyt(1) = 1wread(9)                              'odczytujemy wszystkie 9 bajtw
Rem         For N = 1 To 9
Rem            Print Hex(odczyt(n)) ;                          'pokazujemy wszystkie 9 bajtw odczytane z czujnika
Rem         Next N
         Crc = Crc8(odczyt(1) , 8)                          'obliczamy sume CRC dla odebranych danych
         If Crc <> Odczyt(9) Then                           'porownujemy z odebranym CRC
            Crc_ok = 0                                      'i ustawiamy frage CRC_OK
         End If
         T = Odczyt(2)
         Shift T , Left , 8
         T = T + Odczyt(1)
         T_suma = T_suma + T                                'aktualizaujemy sum odczytw
         T2 = T * 0.0625
         Print T2 ; ";";
      Next Numer
   End If

   T2 = T_suma * 0.0625                                     ' przeliczamy sum temperatur z 1/16 stopnia Celsjusza na liczb rzeczywist
   Print "SUMA=" ; T2 ; ";";                                'pokazujemy sum odczytw

   If Crc_ok = 1 Then
      Print "CRC=OK";
   Else
      Print "CRC=ERROR";
   End If
   Print ";k"

End Sub